<?php

namespace app\controllers;

use Yii;
use yii\base\InvalidArgumentException;
use yii\web\BadRequestHttpException;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use common\models\LoginForm;
//additional
use app\models\Store;
use app\models\ShopifyClient;
use app\models\Configurations;
use app\models\Orders;
use app\models\CartDetails;
use app\models\MobileMoneyPayments;
//use yii\helpers\Url;
use SquareConnect;
use CybsSoapClient;
use yii\web\Response;
/**
 * Site controller
 */
class CheckoutController extends Controller {

    public function beforeAction($action) {
        $this->enableCsrfValidation = false;
        return parent::beforeAction($action);
    }

    /**
     * Render proxy checkout
     antzaradev1.myshopify.com_square_detail
     */
    public function actionIndex() {

        $shop = Yii::$app->request->get('shop');
        $shop = $shop == "calmupcbd.com" || $shop == "leaf-budi.myshopify.com" ? 'leaf-budi.myshopify.com' : $shop;

        $model = Configurations::find()->where(['meta_key' => $shop . '_square_detail'])->one();
        $square_app_id = false;
        $square = false;
        $sandbox = false;
        if ($model !== null) {
            $config = unserialize($model->meta_value);
            if ((isset($config['sandbox']) && $config['sandbox'] == '1')) {
                $sandbox = true;
                $square = true;
                $square_app_id = $config['sandbox_application_id'];
            } else if (isset($config['enable_square']) && $config['enable_square'] == '1') {
                $square = true;
                $square_app_id = $config['live_application_id'];
            } else {
                $square = false;
            }
        }
      return  $this->render('index', ['square' => $square, 'square_app_id' => $square_app_id, 'sandbox' => $sandbox]);
    } 

    /**
     *  Get Shopify store countries drop-down
     */
    public function actionGetcountries() {
        ob_start();
        $shop = Yii::$app->request->get('store');
        $Store = Store::find()->where(['name' =>'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
        $shop = $Store->name;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $orderData = $sc->call('GET', '/admin/countries.json');
        $data = json_encode($orderData);
        echo "getcountries(" . $data . ");";
    }

    /**
     *  Get Shopify store countries drop-down
     */
    public function actionGetlocations() {
        ob_start();
        $shop = Yii::$app->request->get('store');
        $Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
        $shop = $Store->name;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $orderData = $sc->call('GET', '/admin/locations.json');
        $data = json_encode($orderData);
        echo "getlocations(" . $data . ");";
    }

    /**
     *  Get Shopify store province drop-down
     */
    public function actionGetprovinces() {

        ob_start();
        $shop = Yii::$app->request->get('store');
        $url = Yii::$app->request->get('url');
        $Store = Store::find()->where(['name' =>'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
        $shop = $Store->name;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $orderData = $sc->call('GET', $url);
        $data = json_encode($orderData);
        echo "getprovinces(" . $data . ");";
    }

    /**
     *  Get Shopify billing province dropdown
     */
    public function actionGetbillingprovinces() {
        ob_start();
        $shop = Yii::$app->request->get('store');
        $url = Yii::$app->request->get('url');
        $Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
        $shop = $Store->name;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $orderData = $sc->call('GET', $url);
        $data = json_encode($orderData);
        echo "getbillingprovinces(" . $data . ");";
    }

    /**
     *  Apply Coupon Shopify
     */


    public function actionGetpayments(){
        $shop = Yii::$app->request->get('store');
        $url = Yii::$app->request->get('url');
        $Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
        $shop = $Store->name;
        $url = '/admin/api/2021-01/shipping_zones.json';
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $orderData = $sc->call('GET', $url);
        echo "<pre>";print_r($orderData);exit;
        $data = json_encode($orderData);
    }

    public function actionApplycoupon() {

        ob_start();
        $price_rule = array();
        $shop = Yii::$app->request->get('store');
        $url = Yii::$app->request->get('url');
        $coupon_code = Yii::$app->request->get('coupon_code');
        $coupon_url = '/admin/price_rules.json';
        $Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
        $shop = $Store->name;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $orderData = $sc->call('GET', $coupon_url);
		
               if (!isset($orderData)) {
            $final_dic = array(
                'value' => "Invalid",
            );
            $data = json_encode($final_dic);
            echo "applycoupon(" . $data . ");";
            exit;
        }
        $coupon_list = [];
        foreach ($orderData as $key => $val) {
            $price_rule_id = $val['id'];
            $price_rule[$price_rule_id] = $val;
            $coupon_urlm = '/admin/price_rules/' . $price_rule_id . '/discount_codes.json';
            $coupon_list_detail = $sc->call('GET', $coupon_urlm);
            if (!empty($coupon_list_detail)) {
                $coupon_list = array_merge($coupon_list, $coupon_list_detail);
            } else {
                $coupon_list[] = ["code" => ""];
            }
        }

        date_default_timezone_set('America/Los_Angeles');
        $final_Coupon_Array = [];
        $validStart = true;
        $validEnd = true;
        $validUsage = true;
        foreach ($coupon_list as $key => $val) {
            if (strtoupper($val['code']) == strtoupper($coupon_code)) {
                $price_rule_id = $val['price_rule_id'];

                $final_Coupon_Array['coupon_detail'] = $val;
                $final_Coupon_Array['price_rule'] = $price_rule[$price_rule_id];

                // Validate if Start_at and End_at are valid
                if ($final_Coupon_Array['price_rule']['starts_at'] != "") {
                    $validStart = strtotime($final_Coupon_Array['price_rule']['starts_at']) < time();
                }
                if ($final_Coupon_Array['price_rule']['ends_at'] != "") {
                    $validEnd = strtotime($final_Coupon_Array['price_rule']['ends_at']) > time();
                }
                // Validate if Usage_limit is valid
                if ($final_Coupon_Array['price_rule']['usage_limit'] != "") {
                    $validUsage = $final_Coupon_Array['coupon_detail']['usage_count'] < $final_Coupon_Array['price_rule']['usage_limit'];
                }
                break;
            }
        }
        if (is_array($final_Coupon_Array) && $validStart && $validEnd && $validUsage && !empty($final_Coupon_Array)) {
            //echo "yes coupon found";

            $value = $final_Coupon_Array['price_rule']['value'];
            $value_type = $final_Coupon_Array['price_rule']['value_type'];
            //$target_type=$final_Coupon_Array['price_rule']['target_type'];
            $entitled_product_ids = $final_Coupon_Array['price_rule']['entitled_product_ids'];
            $final_dic = array(
                'value' => $value,
                'value_type' => $value_type,
                'entitled_product_ids' => $entitled_product_ids,
                'coupon_type' => $final_Coupon_Array['price_rule']['target_type']
            );
            $data = json_encode($final_dic);
            echo "applycoupon(" . $data . ");";
        } else {
            //echo "invalid coupon";
            $final_dic = array(
                'value' => "Invalid Coupon",
            );
            $data = json_encode($final_dic);
            echo "applycoupon(" . $data . ");";
        }
    }

    /*
     * Validate email address
     */

    public function actionValidateemail() {
        $email = Yii::$app->request->get('email');
        $record = 'MX';
        list($user, $domain) = explode('@', $email);
        if (checkdnsrr($domain, $record)) {
            $result = array("validation" => "true");
            $res = json_encode($result);
            echo "myJsonMethod(" . $res . ")";
            exit;
        } else {
            $result = array("validation" => "false");
            $res = json_encode($result);
            echo "myJsonMethod(" . $res . ")";
            exit;
        }
    }

    /*
     * Checkout Ajax
     */

    public function actionCheckoutajax() {
   //echo '<pre>';print_r(Yii::$app->request->get('store'));die('here');
        $response = '';
        $shop = Yii::$app->request->get('store');
		
        $Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        $shop = $Store->name;
         $logs = fopen("logs.txt", "a") or die("Unable to open file!");
        fwrite($logs, "\n [" . date("Y-m-d H:i:s A") . "] Checkout: " . json_encode($_GET) . "\n");
        if ($Store == null) {
            fwrite($logs, "Invalid request");
            echo "docheckout('Invalid request);";
            exit;
        }
        $shopify_api_version = Yii::$app->params['SHOPIFY_API_VERSION'];
        $token = $Store->token;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);

        $email = Yii::$app->request->get('email');
        $cart_item = Yii::$app->request->get('cart_item');
        $currency = Yii::$app->request->get('currency');
        $accepts_marketing = Yii::$app->request->get('accept_marketing');
        $shipping_amount = 0;
        $shipping_title = '';
        $shipping_rates = Yii::$app->request->get('shipping_rates');
        if (isset($shipping_rates)) {
            $shipping_title = $shipping_rates['title'];
            $shipping_amount = $shipping_rates['amount'];
        }
        $total_price = (float) Yii::$app->request->get('total_price');
        $amount = $total_price * 100;
        $billing = Yii::$app->request->get('billing_address');
		$location1=Yii::$app->request->get('location');
		$location_address =$location1["name"];

        $billing_address = array(
            "first_name" => $billing["first_name"],
            "last_name" => $billing["last_name"],
            "address1" => $billing['address'],
            "address2" => $billing['apartment'],
            "city" => $billing['city'],
            "phone" => $billing['phone'],
            "company" => $billing['company'],
            "province" => $billing['state'],
            "country" => $billing['country'],
            "zip" => $billing['postal']
        );
		 
        $shipping = Yii::$app->request->get('shipping_address');
        $shipping_address = array(
            "first_name" => $shipping['first_name'],
            "last_name" => $shipping['last_name'],
            "address1" => $shipping['address'],
            "address2" => $shipping['apartment'],
            "city" => $shipping['city'],
            "phone" => $shipping['phone'],
            "company" => $shipping['company'],
            "province" => $shipping['state'],
            "country" => $shipping['country'],
            "zip" => $shipping['postal']
        );
        $line_item = array();
        $line_item_name = array();
        foreach ($cart_item['items'] as $key => $val) {
            $items = array(
			       
//                "title" => $val['title'],
//                'product_id' => $val['product_id'],
                'variant_id' => $val['variant_id'],
                'quantity' => $val['quantity'],
                'price' => $val['price'] / 100,
                'title' => $val['title'],
				
            );
            $title = array(
                 'title' => $val['title']
                );
            $line_item[] = $items;
            $line_item_name[] = $title;
        }
        //$nonce = Yii::$app->request->get('nonce');
        $cart_token = Yii::$app->request->get('token');
        $gateway = Yii::$app->request->get('gateway');
        $name = $billing["first_name"] . " " . $billing["last_name"];
        $payment_status = "";
        $customer_id = "";

        if ($gateway == 'SQUARE') {  // Sequare Gateway selected
            // check sandbox or live.
            $config = Configurations::find()->where(['meta_key' => $shop . '_square_detail'])->one();
            $square_config = unserialize($config->meta_value);
            if (isset($square_config['sandbox']) && $square_config['sandbox'] == '1') {
                $sandbox = TRUE;
            } else {
                $sandbox = FALSE;
            }
        // echo "<pre>";print_r($cart_item);exit;

            // Set Square API credentials.
            $host = $sandbox ? 'https://connect.squareupsandbox.com' : 'https://connect.squareup.com';
            $access_token = $sandbox ? $square_config['sandbox_access_token'] : $square_config['live_access_token'];
            $location_id = $sandbox ? $square_config['sandbox_location_id'] : $square_config['live_location_id'];

            // fwrite($logs, "sandbox: sandbox");

            # setup authorization
            $api_config = new \SquareConnect\Configuration();
            $api_config->setHost($host);
            $api_config->setAccessToken($access_token);
            $api_client = new \SquareConnect\ApiClient($api_config);
            // fwrite($logs, "1");

            $billingAddress = new \SquareConnect\Model\Address();
            $billingAddress->setAddressLine1($billing['address']);
            $billingAddress->setAddressLine2($billing['apartment']);
            $billingAddress->setLocality($billing['city']);
            $billingAddress->setAdministrativeDistrictLevel1($billing['state']);
            $billingAddress->setPostalCode($billing['postal']);
            $billingAddress->setCountry($billing['country']);
            $billingAddress->setFirstName($billing["first_name"]);
            $billingAddress->setLastName($billing["last_name"]);
            $billingAddress->setOrganization($billing['company']);

            // fwrite($logs, "2");
            $shippingAddress = new \SquareConnect\Model\Address();
            $shippingAddress->setAddressLine1($shipping['address']);
            $shippingAddress->setAddressLine2($shipping['apartment']);
            $shippingAddress->setLocality($shipping['city']);
            $shippingAddress->setAdministrativeDistrictLevel1($shipping['state']);
            $shippingAddress->setPostalCode($shipping['postal']);
            $shippingAddress->setCountry($shipping['country']);
            $shippingAddress->setFirstName($shipping["first_name"]);
            $shippingAddress->setLastName($shipping["last_name"]);
            $shippingAddress->setOrganization($shipping['company']);

            // fwrite($logs, "3");
            $squareCustomer = Orders::find()->where(['email' => $email])->andWhere(['!=', 'square_customer_id', 'null'])->one();
            if ($squareCustomer !== null) {
                // fwrite($logs, "4 --" . $squareCustomer->square_customer_id . '--');
                $customer_id = $squareCustomer->square_customer_id;
            } else {
                // Create new customer with address
                $apiInstance = new SquareConnect\Api\CustomersApi($api_client);
                $customer = new \SquareConnect\Model\CreateCustomerRequest();

                $customer->setIdempotencyKey(uniqid());
                $customer->setGivenName($name);
                $customer->setCompanyName($billing['company']);
                $customer->setEmailAddress($email);
                $customer->setAddress($billingAddress);
                $customer->setPhoneNumber($billing['phone']);

                // fwrite($logs, "5");
                try {
                    $customer_response = $apiInstance->createCustomer($customer);
                    $customer_id = $customer_response->getCustomer()->getId();
                    // fwrite($logs, "6");
                } catch (\SquareConnect\ApiException $e) {

                    // fwrite($logs, "Customer error: " . $e->getResponseBody()->errors[0]->category . " " . $e->getResponseBody()->errors[0]->detail);
                    $error['status'] = 'fail';
                    $error['message'] = $e->getResponseBody()->errors[0]->category . " " . $e->getResponseBody()->errors[0]->detail;
                    $response = json_encode($error);
                    echo "docheckout(" . $response . ");";
                    exit;
                }
            }
            // fwrite($logs, "7");

            # create an instance of the Payments API class
            $payments_api = new \SquareConnect\Api\PaymentsApi($api_client);
            $body = new \SquareConnect\Model\CreatePaymentRequest();
            $amountMoney = new \SquareConnect\Model\Money();

            # Monetary amounts are specified in the smallest unit of the applicable currency.
            # This amount is in cents. It's also hard-coded for $1.00, which isn't very useful.
            $amountMoney->setAmount($amount);
            $amountMoney->setCurrency($currency);

            // fwrite($logs, "8");
            $body->setSourceId($nonce);
            $body->setAmountMoney($amountMoney);
            $body->setLocationId($location_id);

            // Set billing and shipping address with Square payment
            $body->setBillingAddress($billingAddress);
            $body->setShippingAddress($shippingAddress);

            // Attach customer_id with Square payment
            if ($customer_id !== "") {
                $body->setCustomerId($customer_id);
            }

            // fwrite($logs, "9");
            # Every payment you process with the SDK must have a unique idempotency key.
            $body->setIdempotencyKey(uniqid());

            try {
                // fwrite($logs, "10");
                $result = $payments_api->createPayment($body);
                // Parse the Payment gateway response
                $response_array = $result->getPayment();
            } catch (\SquareConnect\ApiException $e) {

                // fwrite($logs, "Payment failed: " . $e->getResponseBody()->errors[0]->category . " " . $e->getResponseBody()->errors[0]->detail);
                $error['status'] = 'fail';
                $error['message'] = $e->getResponseBody()->errors[0]->category . " " . $e->getResponseBody()->errors[0]->detail;
                $response = json_encode($error);
                echo "docheckout(" . $response . ");";
                exit;
            }

            //Error Handling
            if ($result->getErrors()) {

                // fwrite($logs, "Error Handling: " . json_encode($result->getErrors()));
                $response = json_encode($result->getErrors());
                echo "docheckout(" . $response . ");";
                exit;
            } else {
                $payment_status = "Success";
            }

            if ($payment_status == "Success") {
                // fwrite($logs, " Payment Success");
                $orderDatanew = array('order' => array(
                        'email' => $email,
                        //'send_fulfillment_receipt'=> true,
                        'send_receipt' => true,
                        'line_items' => $line_item,

                        //'customer' =>$customer,
                        'billing_address' => $billing_address,
                        'taxes_included' => false,
                        'shipping_address' => $shipping_address,
                        'financial_status' => "paid",
                        'fulfillment_status' => "unfulfilled",
                        'checkout_token' => $cart_token
                    )
                );
                // fwrite($logs, '11');
                if (Yii::$app->request->get('customer') != '') {
                    $customer = array(
                        "id" => Yii::$app->request->get('customer'),
                    );
                    $orderDatanew['order']['customer'] = $customer;
                    //    $orderDatanew['order']['customer']['accepts_marketing'] = $accepts_marketing;
                }
//                else {
//                    $orderDatanew['order']['buyer_accepts_marketing'] = true;
//                }
                $orderDatanew['order']['buyer_accepts_marketing'] = $accepts_marketing;
                // fwrite($logs, '12');
                $coupon = Yii::$app->request->get('coupon_detail');
                if ($coupon['coupon_type'] != '') {
                    $discount_code = array(
                        "code" => strtoupper($coupon['coupon_name']),
                        "amount" => abs($coupon['coupon_amount_rate']),
                        "type" => $coupon['coupon_type']
                    );
                    $discount_codes[] = $discount_code;
                    $orderDatanew['order']['discount_codes'] = $discount_codes;
                }
                // fwrite($logs, '13');
                if ($shipping_rates['amount'] != '') {
                    $ship = array(
                        'title' => $shipping_rates['title'],
                        'price' => $shipping_rates['amount']
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
                }
                // fwrite($logs, "14 Order array: " . json_encode($orderDatanew));
                $tax = Yii::$app->request->get('tax_detail');
                if ($tax['tax_price'] != '' && $tax['tax_name'] != '') {
                    $tax_amt = $tax['tax_price'];
                    $tax = array(
                        "title" => $tax['tax_name'],
                        "price" => $tax_amt,
                        "rate" => $tax['tax_rate'],
                    );
                    $taxlines[] = $tax;
                    $orderDatanew['order']['tax_lines'] = $taxlines;
                    $orderDatanew['order']['total_tax'] = $tax_amt;
                }
                if ($currency == 'EUR') {
                    $orderDatanew['order']['taxes_included'] = true;
                }
                $txn = array(
                    "kind" => "sale",
                    "status" => "success",
                    "amount" => $total_price,
                    "gateway" => "Credit Card"
                );
                // fwrite($logs, json_encode($txn));
                $transacrtion[] = $txn;
                $orderDatanew['order']['transactions'] = $transacrtion;
                // fwrite($logs, "\n Complete Order array: " . json_encode($orderDatanew));
                $orderData = $sc->call('POST', "/admin/api/$shopify_api_version/orders.json", $orderDatanew);
                // fwrite($logs, '\n Created-order -' . json_encode($orderData));
                // fwrite($logs, '\n API version -' . "/admin/api/$shopify_api_version/orders.json");
                if (!empty($orderData['errors'])) {
                    // fwrite($logs, "\n New Order error " . json_encode($orderData));
                    $err_response['status'] = 'fail';
                    $err_response['message'] = 'something went wrong';

                    if (!empty($orderData['errors']['customer'])) {
                        $err_response['message'] = $orderData['errors']['customer'][0];
                    }
                    $response = json_encode($err_response);
                    echo "docheckout(" . $response . ");";
                    exit;
                }
                $orderid = $orderData['id'];
                if ($orderData['id']) {
                    // fwrite($logs, "New Order placed $orderid \n\n");
                    $store_id = $Store->id;
                    $payment_mode = "Card";

                    $order_name = $orderData['name'];
                    $this->actionSavetransactiondetail($store_id, $orderid, $order_name, $response_array, $payment_mode, $name, $email, $billing['postal'], $billing['country'], $gateway, $amount, $currency, $customer_id);

                    $dd = array('status_message' => "payment has been created successfully.");
                    $new_url = str_replace('checkout.shopify.com', $shop, $orderData['order_status_url']);
                    $dd['response'] = $new_url;
                    $dd['order_id'] = $orderid;
                    $response = json_encode($dd);
                    echo "docheckout(" . $response . ");";
                }
            }
        }
        if ($gateway == 'Stripe') { 
         
        if(!empty($_GET['stripeToken'])){
            // get token and user details
            $stripeToken  = $_GET['stripeToken'];
            $custName = $_GET['custName'];
            $custEmail = $_GET['email'];
            $cardNumber = $_GET['cardNumber'];
            $cardCVC = $_GET['cardCVC'];
            $cardExpMonth = $_GET['cardExpMonth'];
            $cardExpYear = $_GET['cardExpYear'];
   
            //include Stripe PHP library
            require_once ('/home/development/public_html/Zanacocheckout/vendor/stripe/stripe-php/init.php');    
            //set stripe secret key and publishable key
            $stripe = array(
              "secret_key"      => "sk_test_51IByC7IqaoqzHHQY69ubYJvJSzpRAoxMK4c2qY6SV2vbR1pzfvTlKhGt0YAt7hDyORhuP628OzJ1xtunk9iqyAPG00qXdnnacx",
              "publishable_key" => "pk_test_51IByC7IqaoqzHHQYJusunwyJMmYpcu7maItsNqyaBBcDJ7oEqLnriyROf59pHwMS6Pact7H0t5MnsQnB3Jo12dpM00WKcTyQgd"
            );    
            \Stripe\Stripe::setApiKey($stripe['secret_key']);    
            //add customer to stripe
            $customer = \Stripe\Customer::create(array(
                'email' => $custEmail,
                'source'  => $stripeToken
            ));
            
            // item details for which payment made
            
            $orderID = "SKA987654322";    
            // details for which payment performed
            $payDetails = \Stripe\Charge::create(array(
                'customer' =>  $customer->id,
                'amount'   => $amount,
                'currency' => $currency,
                'description' => "Antzara",
                'shipping' => [
                'name' => $custName,
                'address' => [
                  'line1' => $_GET['billing_address']['address'],
                  'postal_code' => $_GET['billing_address']['postal'],
                  'city' => $_GET['billing_address']['city'],
                  'state' => $_GET['billing_address']['state'],
                  'country' => $_GET['billing_address']['country'],
                ],
              ],
                
            ));    
            // get payment details
            $paymenyResponse = $payDetails->jsonSerialize();
            // check whether the payment is successful
            if($paymenyResponse['amount_refunded'] == 0 && empty($paymenyResponse['failure_code']) && $paymenyResponse['paid'] == 1 && $paymenyResponse['captured'] == 1){
               
                // transaction details 
                $amountPaid = $paymenyResponse['amount'];
                $balanceTransaction = $paymenyResponse['balance_transaction'];
                $paidCurrency = $paymenyResponse['currency'];
                $paymentStatus = $paymenyResponse['status'];
                $paymentDate = date("Y-m-d H:i:s");   
                $orderDatanew = array('order' => array(
                        'email' => $email,
                        //'send_fulfillment_receipt'=> true,
                        'send_receipt' => true,
                        'line_items' => $line_item,
                        //'customer' =>$customer,
                        'billing_address' => $billing_address,
                        'taxes_included' => false,
                        'shipping_address' => $shipping_address,
                        'financial_status' => "paid",
                        'fulfillment_status' => "unfulfilled",
                        'checkout_token' => $cart_token
                    )
                ); 
                if (Yii::$app->request->get('customer') != '') {
                    $customer = array(
                        "id" => Yii::$app->request->get('customer'),
                    );
                    $orderDatanew['order']['customer'] = $customer;
                    //    $orderDatanew['order']['customer']['accepts_marketing'] = $accepts_marketing;
                }
                $orderDatanew['order']['buyer_accepts_marketing'] = $accepts_marketing;
                // fwrite($logs, '12');
                $coupon = Yii::$app->request->get('coupon_detail');
                if ($coupon['coupon_type'] != '') {
                    $discount_code = array(
                        "code" => strtoupper($coupon['coupon_name']),
                        "amount" => abs($coupon['coupon_amount_rate']),
                        "type" => $coupon['coupon_type']
                    );
                    $discount_codes[] = $discount_code;
                    $orderDatanew['order']['discount_codes'] = $discount_codes;
                }
				if(!empty($location1)){
					$ship = array(
                        'title' => 'pickup ('.$location1['name'].')',
                        'price' => $shipping_rates['amount'],
						'code'=>'pickup ('.$location1['name'].')',
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
				}
                else if ($shipping_rates['amount'] != '') {
                    $ship = array(
                        'title' => $shipping_rates['title'],
                        'price' => $shipping_rates['amount']
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
                }
                $tax = Yii::$app->request->get('tax_detail');
                if ($tax['tax_price'] != '' && $tax['tax_name'] != '') {
                    $tax_amt = $tax['tax_price'];
                     $tax_rate = 0;
                    $tax = array(
                        "title" => $tax['tax_name'],
                        "price" => $tax_amt,
                        "rate" => $tax_rate,
                    );
                    $taxlines[] = $tax;
                    $orderDatanew['order']['tax_lines'] = $taxlines;
                    $orderDatanew['order']['total_tax'] = $tax_amt;
                }
                if ($currency == 'EUR') {
                    $orderDatanew['order']['taxes_included'] = true;
                }
                $txn = array(
                    "kind" => "sale",
                    "status" => "success",
                    "amount" => $total_price,
                    "gateway" => "Stripe"
                );
                $transacrtion[] = $txn;
                $orderDatanew['order']['transactions'] = $transacrtion;
             
                $orderData = $sc->call('POST', "/admin/api/$shopify_api_version/orders.json", $orderDatanew);
                
                if (!empty($orderData['errors'])) {
                    // fwrite($logs, "\n New Order error " . json_encode($orderData));
                    $err_response['status'] = 'fail';
                    $err_response['message'] = 'something went wrong';

                    if (!empty($orderData['errors']['customer'])) {
                        $err_response['message'] = $orderData['errors']['customer'][0];
                    }
                    $response = json_encode($err_response);
                    echo "docheckout(" . $response . ");";
                    exit;
                } 
                $orderid = $orderData['id']; 
                if ($orderData['id']) {
                    // fwrite($logs, "New Order placed $orderid \n\n");
                    $store_id = $Store->id;
                    $payment_mode = "Stripe";

                    $order_name = $orderData['name'];
                    $this->actionSavetransactiondetail($store_id, $orderid, $order_name, $paymenyResponse, $payment_mode, $name, $email, $billing['postal'], $billing['country'], $gateway, $amount, $currency, $customer_id);

//                    $model = new CartDetails();
//                    $model->order_id = $orderid;
//                    $model->cart_token = $cart_token;
//                    $model->save(false);

                    $dd = array('status_message' => "payment has been created successfully.");
                    $new_url = str_replace('checkout.shopify.com', $shop, $orderData['order_status_url']);
                    $dd['response'] = $new_url;
                    $dd['order_id'] = $orderid;
                    $response = json_encode($dd);
                    echo "docheckout(" . $response . ");";
                }  
                //insert tansaction details into database
                
            } else{
                $paymentMessage = "Payment failed!";
            }
        } else{
            $paymentMessage = "Payment failed!";
        }
        
        
        }
		//if ($gateway == 'Credit Card or Debit Card') {
			//  return $this->redirect(['cybersource/payment_form']);

			// $cardNumber = $_GET['cardNumber'];
          //  $cardCVC = $_GET['cardCVC'];
          //  $cardExpMonth = $_GET['cardExpMonth'];
          //  $cardExpYear = $_GET['cardExpYear'];
		//	$referenceCode = '123333'; 

			// covert currency from ZMW to USD
		//	$amt= Yii::$app->request->get('total_price');
		//	$curr= Yii::$app->request->get('currency');
		
		 // $amount = ($amt)?($amt):(1);
 
     // $apikey = 'd1ded944220ca6b0c442';
 
     // $from_Currency = urlencode($curr);
     // $to_Currency = urlencode('USD');
     // $query =  $from_Currency.'_'.$to_Currency;
 
      // change to the free URL if you're using the free version
      //$json = file_get_contents("http://free.currencyconverterapi.com/api/v5/convert?q=$query&compact=y&apiKey=f8bb5907c22d4023f60e");
 
      //$obj = json_decode($json, true);
       
      //$val = $obj["$query"];
 
     //$total = $val['val'] * 1;
 
      //$formatValue = number_format($total, 2, '.', '');
       
      //$data = $formatValue;
 
				//$client = new CybsSoapClient();
				//$request = $client->createRequest($referenceCode);

				
				//$ccAuthService = new \stdClass();
				//$ccAuthService->run = 'true';
				//$request->ccAuthService = $ccAuthService;

				//$ccCaptureService = new \stdClass();
				//$ccCaptureService->run = 'true';
				//$request->ccCaptureService = $ccCaptureService;

				//$billTo = new \stdClass();
				//$billTo->firstName = $billing['first_name'];
				//$billTo->lastName = $billing['last_name'];
				//$billTo->street1 = $billing['address'];
				//$billTo->city =  $billing['city'];
				//$billTo->state = $billing['state'];
				//$billTo->postalCode =  $billing['postal'];
				//$billTo->country = $billing['country'];
				//$billTo->email =$email;
				//$billTo->ipAddress = '10.7.111.111';
				//$request->billTo = $billTo;

				//$card = new \stdClass();
				
				//$card->accountNumber =  $cardNumber;
				//$card->expirationMonth = $cardExpMonth;
				//$card->expirationYear =$cardExpYear;
				//$request->card = $card;

				//$purchaseTotals = new \stdClass();
				//$purchaseTotals->currency ='USD';
				//$purchaseTotals->grandTotalAmount =  $data;
				//$request->purchaseTotals = $purchaseTotals;

				//$reply = $client->runTransaction($request);
				
			//	$code=$reply->reasonCode;
			//	$message=$reply->decision;
				
			//	if($code!=100){
				//	$err_response['status'] = 'fail';
				//	$err_response['response'] = $reply;
				//	$err_response['message'] = 'Something went wrong';
				//	$error=json_encode($err_response);
				//	echo "docheckout(".$error.");";
				//	exit;
				//}else{
					
				
			
			
			//$paymentDate = date("Y-m-d H:i:s");   
               // $orderDatanew = array('order' => array(
                     //   'email' => $email,
                     //   'send_receipt' => true,
                      //  'line_items' => $line_item,
                     //   //'customer' =>$customer,
                     //   'billing_address' => $billing_address,
                     //   'taxes_included' => false,
                     //   'shipping_address' => $shipping_address,
                     //   'financial_status' => "paid",
                     //   'fulfillment_status' => "unfulfilled",
                    //    'checkout_token' => $cart_token
                 //   )
               // ); 
               // if (Yii::$app->request->get('customer') != '') {
                //    $customer = array(
                //        "id" => Yii::$app->request->get('customer'),
                 //   );
                //    $orderDatanew['order']['customer'] = $customer;
                 //   //    $orderDatanew['order']['customer']['accepts_marketing'] = $accepts_marketing;
               // }
               // $orderDatanew['order']['buyer_accepts_marketing'] = $accepts_marketing;
                // fwrite($logs, '12');
               // $coupon = Yii::$app->request->get('coupon_detail');
               // if ($coupon['coupon_type'] != '') {
                //    $discount_code = array(
                //        "code" => strtoupper($coupon['coupon_name']),
                 //       "amount" => abs($coupon['coupon_amount_rate']),
                //        "type" => $coupon['coupon_type']
                //    );
                //    $discount_codes[] = $discount_code;
               //     $orderDatanew['order']['discount_codes'] = $discount_codes;
               // }
				//if(!empty($location1)){
				//	$ship = array(
                 //       'title' => 'pickup ('.$location1['name'].')',
                 //       'price' => $shipping_rates['amount'],
				//		'code'=>'pickup ('.$location1['name'].')',
                 //   );
                //    $shippinglines[] = $ship;
                //    $orderDatanew['order']['shipping_lines'] = $shippinglines;
				//}
               // else if ($shipping_rates['amount'] != '') {
                //    $ship = array(
                 //       'title' => $shipping_rates['title'],
                 //       'price' => $shipping_rates['amount']
                //    );
                //    $shippinglines[] = $ship;
               //     $orderDatanew['order']['shipping_lines'] = $shippinglines;
              //  }
               // $tax = Yii::$app->request->get('tax_detail');
               // if ($tax['tax_price'] != '' && $tax['tax_name'] != '') {
                 //   $tax_amt = $tax['tax_price'];
                //     $tax_rate = 0;
                 //   $tax = array(
                 //       "title" => $tax['tax_name'],
                 //       "price" => $tax_amt,
                 //       "rate" => $tax_rate,
                 //   ); 
               //     $taxlines[] = $tax;
               //     $orderDatanew['order']['tax_lines'] = $taxlines;
               //     $orderDatanew['order']['total_tax'] = $tax_amt;
              //  }
              //  if ($currency == 'EUR') {
              //      $orderDatanew['order']['taxes_included'] = true;
              //  }
               // $txn = array(
               //     "kind" => "sale",
              //      "status" => "success",
              //      "amount" => $total_price,
              //      "gateway" => "Credit Card or Debit Card"
              //  );
              //  $transacrtion[] = $txn;
              //  $orderDatanew['order']['transactions'] = $transacrtion;
				
               // $orderData = $sc->call('POST', "/admin/api/$shopify_api_version/orders.json", $orderDatanew);
                
				//if (!empty($orderData['errors'])) {
                //     fwrite($logs, "\n New Order error " . json_encode($orderData));
                //    $err_response['status'] = 'fail';
               //     $err_response['message'] = $total_price;

                //    if (!empty($orderData['errors']['customer'])) {
                //        $err_response['message'] = $orderData['errors']['customer'][0];
                //    }
                //    $response = json_encode($err_response);
               //     echo "docheckout(" . $response . ");";
               //     exit;
               // } 
               // $orderid = $orderData['id']; 
               // if ($orderData['id']) {
                   // $store_id = $Store->id;
                  //  $payment_mode = $gateway;
                  //  $paymenyResponse = "Pending";
                 //   $order_name = $orderData['name'];
                 //   $this->actionSavetransactiondetail($store_id, $orderid, $order_name, $paymenyResponse, $payment_mode, $name, $email, $billing['postal'], $billing['country'], $gateway, $amount, $currency, $customer_id);

                 //   $dd = array('status_message' => "payment has been created successfully.");
                    
						
				//	$model=new MobileMoneyPayments();
				//	$model->card_number=$cardNumber;
				//	$model->card_expmonth=$cardExpMonth;
				//	$model->card_expyear=$cardExpYear;
				//	$model->grandTotalAmount=$data;
				//	$model->currency='USD';
				//	$model->merchant_code=$referenceCode;
				//	$model->requestID=$reply->requestID;
				//	$model->decision=$reply->decision;
				//	$model->reasonCode=$reply->ccCaptureReply->reasonCode;
				//	$model->requestToken=$reply->requestToken;
				//	$model->reconciliationID=$reply->ccCaptureReply->reconciliationID;
				//	$model->paymentNetworkTransactionID=$reply->ccAuthReply->paymentNetworkTransactionID;
				//	$model->authorizationCode=$reply->ccAuthReply->authorizationCode;
				//	$model->cardType=$reply->card->cardType;
					//$model->terminalID=$reply->pos->terminalID;
					//$model->orderid= $orderid;
					////$model->created_at= date('m/d/Y');
					////$model->updated_at= date('m/d/Y');
				//	$model->save(false);
				//	$new_url = str_replace('checkout.shopify.com', $shop, $orderData['order_status_url']);
				//	//print_r($new_url);die();
                //    $dd['response'] = $new_url;
               //     $dd['order_id'] = $orderid;
               //     $response = json_encode($dd);
					
              //     echo "docheckout(" . $response . ");";
            //    }
			
			//	}
		//}
        if ($gateway == 'COD') {    
              
                $paymentDate = date("Y-m-d H:i:s");   
                $orderDatanew = array('order' => array(
                        'email' => $email,
                        //'send_fulfillment_receipt'=> true,
                        'send_receipt' => true,
                        //'customer' =>$customer,
                        'billing_address' => $billing_address,
                        'taxes_included' => false,
                       'shipping_address' => $shipping_address,
                        'financial_status' => "pending",
                        'fulfillment_status' => "unfulfilled",
						'line_items' => $line_item,
	
                        'checkout_token' => $cart_token
                    )
                ); 
                if (Yii::$app->request->get('customer') != '') {
                    $customer = array(
                        "id" => Yii::$app->request->get('customer'),
                    );
                    $orderDatanew['order']['customer'] = $customer;
                    //    $orderDatanew['order']['customer']['accepts_marketing'] = $accepts_marketing;
                }
                $orderDatanew['order']['buyer_accepts_marketing'] =false;
				                $orderDatanew['order']['processing_method'] ='manual';
                $coupon = Yii::$app->request->get('coupon_detail');
                if ($coupon['coupon_type'] != '') {
                    $discount_code = array(
                        "code" => strtoupper($coupon['coupon_name']),
                        "amount" => abs($coupon['coupon_amount_rate']),
                        "type" => $coupon['coupon_type']
                    );
                    $discount_codes[] = $discount_code;
                    $orderDatanew['order']['discount_codes'] = $discount_codes;
                }
				if(!empty($location1)){
					$ship = array(
                        'title' => 'pickup ('.$location1['name'].')',
                        'price' => $shipping_rates['amount'],
						'code'=>'pickup ('.$location1['name'].')',
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
				}
                else if ($shipping_rates['amount'] != '') {
                    $ship = array(
                        'title' => $shipping_rates['title'],
                        'price' => $shipping_rates['amount']
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
                }
                $tax = Yii::$app->request->get('tax_detail');
                if ($tax['tax_price'] != '' && $tax['tax_name'] != '') {
                    $tax_amt = $tax['tax_price'];
                     $tax_rate = 0;
                    $tax = array(
                        "title" => $tax['tax_name'],
                        "price" => $tax_amt,
                        "rate" => $tax_rate,
                    ); 
                    $taxlines[] = $tax;
                    $orderDatanew['order']['tax_lines'] = $taxlines;
                    $orderDatanew['order']['total_tax'] = $tax_amt;
                }
                if ($currency == 'EUR') {
                    $orderDatanew['order']['taxes_included'] = true;
                }
              //  $txn = array(
              //      "kind" => "sale",
              //      "status" => "success",
               //     "amount" => $total_price,
               //     "gateway" => "In-Store Cash Payment"
               // );
               // $transacrtion[] = $txn;
              //  $orderDatanew['order']['transactions'] = $transacrtion;

                $orderData = $sc->call('POST', "/admin/api/$shopify_api_version/orders.json", $orderDatanew);
                
                if (!empty($orderData['errors'])) {
                    // fwrite($logs, "\n New Order error " . json_encode($orderData));
                    $err_response['status'] = 'fail';
                    $err_response['message'] = 'something went wrong';

                    if (!empty($orderData['errors']['customer'])) {
                        $err_response['message'] = $orderData['errors']['customer'][0];
                    }
                    $response = json_encode($err_response);
                    echo "docheckout(" . $response . ");";
                    exit;
                } 
                $orderid = $orderData['id']; 

                if ($orderData['id']) {
					
              
                    $store_id = $Store->id;
                    $payment_mode = "In-Store Cash Payment";
                    $paymenyResponse = "Pending";
                    $order_name = $orderData['name'];
                    $this->actionSavetransactiondetail($store_id, $orderid, $order_name, $paymenyResponse, $payment_mode, $name, $email, $billing['postal'], $billing['country'], $gateway, $amount, $currency, $customer_id);

                    $dd = array('status_message' => "payment has been created successfully.");
                    $new_url = str_replace('checkout.shopify.com', $shop, $orderData['order_status_url']);
                    $dd['response'] = $new_url;
                    $dd['order_id'] = $orderid;
                    $response = json_encode($dd);
                    echo "docheckout(" . $response . ");";
                }  
        }
    }

    public function actionSavetransactiondetail($store_id, $orderid, $order_name, $response, $payment_mode, $name, $email, $postal, $country, $gateway, $amount, $currency, $customer_id) {
        $Ordersave = new Orders();
        $Ordersave->store_id = $store_id;
        $Ordersave->order_id = $orderid;
        $Ordersave->order_name = $order_name;
        $Ordersave->customer_name = $name;
        $Ordersave->email = $email;
        $Ordersave->pin = $postal;
        $Ordersave->country = $country;

        if ($gateway == "SQUARE") {
            $card = $response->getCardDetails()->getCard();
            $Ordersave->sequare_payment_id = $response->getId();
            $Ordersave->square_customer_id = $customer_id;
            $Ordersave->amount = $amount;
            $Ordersave->currency = $currency;
            $Ordersave->card_status = $response->getCardDetails()->getStatus();
            $Ordersave->card_brand = $card->getCardBrand();
            $Ordersave->last_4 = $card->getLast4();
            $Ordersave->expiry = $card->getExpMonth() . ' ' . $card->getExpYear();
            $Ordersave->location_id = $response->getLocationId();
            $Ordersave->square_order_id = $response->getOrderId();
            $Ordersave->status = $response->getStatus();
        }

        $Ordersave->payment_mode = $payment_mode;
        $Ordersave->save(false);
    }

    /*
     * Checkout with total $0
     */

    public function actionProcessCheckout() {

        ob_start();
        $response = '';
        $shop = Yii::$app->request->get('store');
        $shop = $shop == "calmupcbd.com" || $shop == "leaf-budi.myshopify.com" ? 'leaf-budi.myshopify.com' : $shop;
        $Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        if ($Store == null) {
            echo "docheckout('Invalid request);";
            exit;
        }
        $token = $Store->token;
        $shop = $Store->name;
        $sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
        $email = Yii::$app->request->get('email');
        $cart_item = Yii::$app->request->get('cart_item');
        $currency = Yii::$app->request->get('currency');
        $shipping_amount = 0;
        $shipping_title = '';
        $shipping_rates = Yii::$app->request->get('shipping_rates');
        if (isset($shipping_rates)) {
            $shipping_title = $shipping_rates['title'];
            $shipping_amount = $shipping_rates['amount'];
        }
        $total_price = (float) Yii::$app->request->get('total_price');
        $billing = Yii::$app->request->get('billing_address');
        $billing_address = array(
            "first_name" => $billing["first_name"],
            "last_name" => $billing["last_name"],
            "address1" => $billing['address'],
            "address2" => $billing['apartment'],
            "city" => $billing['city'],
            "phone" => $billing['phone'],
            "company" => $billing['company'],
            "province" => $billing['state'],
            "country" => $billing['country'],
            "zip" => $billing['postal']
        );
        $shipping = Yii::$app->request->get('shipping_address');
        $shipping_address = array(
            "first_name" => $shipping['first_name'],
            "last_name" => $shipping['last_name'],
            "address1" => $shipping['address'],
            "address2" => $shipping['apartment'],
            "city" => $shipping['city'],
            "phone" => $shipping['phone'],
            "company" => $shipping['company'],
            "province" => $shipping['state'],
            "country" => $shipping['country'],
            "zip" => $shipping['postal']
        );
        $line_item = array();
        foreach ($cart_item['items'] as $key => $val) {
            $items = array(
                'variant_id' => $val['variant_id'],
                'quantity' => $val['quantity'],
                'price' => $val['price'] / 100
            );
            $line_item[] = $items;
        }
        $nonce = Yii::$app->request->get('nonce');
        $cart_token = Yii::$app->request->get('token');
        if ($nonce == '0') {  // Sequare Gateway selected
            $orderDatanew = array('order' => array(
                    'email' => $email,
                    //'send_fulfillment_receipt'=> true,
                    'send_receipt' => true,
                    'line_items' => $line_item,
                    //'customer' =>$customer,
                    'billing_address' => $billing_address,
                    'taxes_included' => false,
                    'shipping_address' => $shipping_address,
                    'financial_status' => "paid",
                    'fulfillment_status' => "unfulfilled",
                    'checkout_token' => $cart_token
                )
            );
            if (Yii::$app->request->get('customer') != '') {
                $customer = array(
                    "id" => Yii::$app->request->get('customer'),
                );
                $orderDatanew['order']['customer'] = $customer;
            } else {
                $orderDatanew['order']['buyer_accepts_marketing'] = true;
            }
            $coupon = Yii::$app->request->get('coupon_detail');
            if ($coupon['coupon_type'] != '') {
                $discount_code = array(
                    "code" => strtoupper($coupon['coupon_name']),
                    "amount" => abs($coupon['coupon_amount_rate']),
                    "type" => $coupon['coupon_type']
                );
                $discount_codes[] = $discount_code;
                $orderDatanew['order']['discount_codes'] = $discount_codes;
            }
			if(!empty($location1)){
					$ship = array(
                        'title' => 'pickup ('.$location1['name'].')',
                        'price' => $shipping_rates['amount'],
						'code'=>'pickup ('.$location1['name'].')',
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
				}
                else if ($shipping_rates['amount'] != '') {
                $ship = array(
                    'title' => $shipping_rates['title'],
                    'price' => 0
                );
                $shippinglines[] = $ship;
                $orderDatanew['order']['shipping_lines'] = $shippinglines;
            }
            $tax = Yii::$app->request->get('tax_detail');
           
            if ($tax['tax_price'] != '' && $tax['tax_name'] != '') {
                $tax_amt = $tax['tax_price'];
                $tax = array(
                    "title" => $tax['tax_name'],
                    "price" => $tax_amt,
                    //"rate" => $tax['tax_rate'],
                );
                $taxlines[] = $tax;
                $orderDatanew['order']['tax_lines'] = $taxlines;
                $orderDatanew['order']['total_tax'] = $tax_amt;
            }
            if ($currency == 'EUR') {
                $orderDatanew['order']['taxes_included'] = true;
            }
            //echo '<pre>';print_r($orderDatanew); die;
            $orderData = $sc->call('POST', "/admin/orders.json", $orderDatanew);
            if (!empty($orderData['errors'])) {

                $err_response['status'] = 'fail';
                $err_response['message'] = 'something went wrong';

                if (!empty($orderData['errors']['customer'])) {
                    $err_response['message'] = $orderData['errors']['customer'][0];
                }
                $response = json_encode($err_response);
                echo "docheckout(" . $response . ");";
                exit;
            }
            if ($orderData['id']) {
//                $model = new CartDetails();
//                $model->order_id = $orderData['id'];
//                $model->cart_token = $cart_token;
//                $model->save();
                $dd = array('status_message' => "Order has been created successfully.");
                $new_url = str_replace('checkout.shopify.com', $shop, $orderData['order_status_url']);
                $dd['response'] = $new_url;
                $response = json_encode($dd);
                echo "docheckout(" . $response . ");";
            }
        }
    }

    public function actionTest() {
        $base_url = Yii::$app->params['BASE_URL'];
        $version = Yii::$app->params['SHOPIFY_API_VERSION'];
        $shop = 'leaf-budi.myshopify.com';
        $token = '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';
        $key = '9b1f8056f9c7a212b389af37cfe29e8e';
        $secret = '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';

        $sc = new ShopifyClient($shop, $token, $key, $secret);
         $customer = $sc->call('GET', "/admin/api/$version/price_rules.json");   
        $discounts = $sc->call('GET', "/admin/api/$version/price_rules/735443157155/discount_codes.json");
        echo '<pre>';
        print_r($discounts);
    }

    public function actionProcess(){
        
        if(!empty($_POST['stripeToken'])){
            // get token and user details
            $stripeToken  = $_POST['stripeToken'];
            $custName = $_POST['custName'];
            $custEmail = $_POST['custEmail'];
            $cardNumber = $_POST['cardNumber'];
            $cardCVC = $_POST['cardCVC'];
            $cardExpMonth = $_POST['cardExpMonth'];
            $cardExpYear = $_POST['cardExpYear'];    
            //include Stripe PHP library
            require_once('stripe-php/init.php');    
            //set stripe secret key and publishable key
            $stripe = array(
              "secret_key"      => "sk_test_51IByC7IqaoqzHHQY69ubYJvJSzpRAoxMK4c2qY6SV2vbR1pzfvTlKhGt0YAt7hDyORhuP628OzJ1xtunk9iqyAPG00qXdnnacx",
              "publishable_key" => "pk_test_51IByC7IqaoqzHHQYJusunwyJMmYpcu7maItsNqyaBBcDJ7oEqLnriyROf59pHwMS6Pact7H0t5MnsQnB3Jo12dpM00WKcTyQgd"
            );    
            \Stripe\Stripe::setApiKey($stripe['secret_key']);    
            //add customer to stripe
            $customer = \Stripe\Customer::create(array(
                'email' => $custEmail,
                'source'  => $stripeToken
            ));    
            // item details for which payment made
            $itemName = "phpzag test item";
            $itemNumber = "PHPZAG987654321";
            $itemPrice = 50;
            $currency = "usd";
            $orderID = "SKA987654321";    
            // details for which payment performed
            $payDetails = \Stripe\Charge::create(array(
                'customer' => $customer->id,
                'amount'   => $itemPrice,
                'currency' => $currency,
                'description' => $itemName,
                'metadata' => array(
                    'order_id' => $orderID
                )
            ));    
            // get payment details
            $paymenyResponse = $payDetails->jsonSerialize();
            // check whether the payment is successful
            if($paymenyResponse['amount_refunded'] == 0 && empty($paymenyResponse['failure_code']) && $paymenyResponse['paid'] == 1 && $paymenyResponse['captured'] == 1){
                // transaction details 
                $amountPaid = $paymenyResponse['amount'];
                $balanceTransaction = $paymenyResponse['balance_transaction'];
                $paidCurrency = $paymenyResponse['currency'];
                $paymentStatus = $paymenyResponse['status'];
                $paymentDate = date("Y-m-d H:i:s");        
                //insert tansaction details into database
                include_once("../db_connect.php");
                $insertTransactionSQL = "INSERT INTO transaction(cust_name, cust_email, card_number, card_cvc, 
                card_exp_month, card_exp_year,item_name, item_number, item_price, item_price_currency,
                paid_amount, paid_amount_currency, txn_id, payment_status, created, modified) 
                VALUES('".$custName."','".$custEmail."','".$cardNumber."','".$cardCVC."','".$cardExpMonth."',
                '".$cardExpYear."','".$itemName."','".$itemNumber."','".$itemPrice."','".$paidCurrency."',
                '".$amountPaid."','".$paidCurrency."','".$balanceTransaction."','".$paymentStatus."',
                '".$paymentDate."','".$paymentDate."')";
            mysqli_query($conn, $insertTransactionSQL) or die("database error: ". 
                mysqli_error($conn));
                $lastInsertId = mysqli_insert_id($conn);        
                //if order inserted successfully
               if($lastInsertId && $paymentStatus == 'succeeded'){
                    $paymentMessage = "The payment was successful. Order ID: {$lastInsertId}";
               } else{
                  $paymentMessage = "Payment failed!";
               }
            } else{
                $paymentMessage = "Payment failed!";
            }
        } else{
            $paymentMessage = "Payment failed!";
        }
        echo $paymentMessage;
        die;
    }
	
	public function actionSoapclient_response(Request $request) {
		echo '<pre>';print_r($request);die();
		
				$referenceCode = '123333'; 

				$client = new CybsSoapClient();
				$request = $client->createRequest($referenceCode);

				
				$ccAuthService = new \stdClass();
				$ccAuthService->run = 'true';
				$request->ccAuthService = $ccAuthService;

				$ccCaptureService = new \stdClass();
				$ccCaptureService->run = 'true';
				$request->ccCaptureService = $ccCaptureService;

				$billTo = new \stdClass();
				$billTo->firstName = $_POST['first_name'];
				$billTo->lastName = $_POST['last_name'];
				$billTo->street1 = $_POST['address'];
				$billTo->city =  $_POST['city'];
				$billTo->state = $_POST['state'];
				$billTo->postalCode =  $_POST['postal'];
				$billTo->country = $_POST['country'];
				$billTo->email = $_POST['email'];
				//$billTo->ipAddress = '10.7.111.111';
				$request->billTo = $billTo;

				$card = new \stdClass();
				
				$card->accountNumber =  $_POST['cardNumber'];
				$card->expirationMonth = $_POST['cardExpMonth'];
				$card->expirationYear =$_POST['cardExpYear'];
				$request->card = $card;

				$purchaseTotals = new \stdClass();
				$purchaseTotals->currency = 'USD';
				$purchaseTotals->grandTotalAmount = '90.01';
				$request->purchaseTotals = $purchaseTotals;

				$reply = $client->runTransaction($request);
				
				$code=$reply->reasonCode;
				$message=$reply->decision;
				
				//print_r($reply->ccAuthReply->reconciliationID);die();
				if($code!=100){
					return $message;
				}else{
					//$shopify_api_version = Yii::$app->params['SHOPIFY_API_VERSION'];
					$shop =$_POST['store'];
					$Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
        $token = $Store->token;
		 $key = '9b1f8056f9c7a212b389af37cfe29e8e';
        $secret = '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';
        $sc = new ShopifyClient($shop, $token,$key,$secret);

        $email = $_POST['email'];
        $cart_item = $_POST['cart_item'];
        $currency ='USD';
        $accepts_marketing = $_POST['accept_marketing'];
        $shipping_amount =$_POST['shipping_amount2'];
        $shipping_title = $_POST['shipping_rates_title'];
        if (isset($_POST['shipping_rates_title'])) {
            $shipping_title =$_POST['shipping_rates_title'];
           
        }
		if (isset($_POST['shipping_rates_amount'])) {
			 $shipping_amount = $_POST['shipping_rates_amount'];
		}
        $total_price = (float) '90.01';
        $amount = $total_price * 100;
        
        $billing_address = array(
            "first_name" => $_POST["first_name"],
            "last_name" => $_POST["last_name"],
            "address1" => $_POST['address'],
            "address2" => $_POST['apartment'],
            "city" => $_POST['city'],
            "phone" => $_POST['phone'],
            "company" => $_POST['company'],
            "province" => $_POST['state'],
            "country" => $_POST['country'],
            "zip" => $_POST['postal']
        
        );
        $shipping_address = array(
            "first_name" => $_POST['first_name2'],
            "last_name" => $_POST['last_name2'],
            "address1" => $_POST['address2'],
            "address2" => $_POST['apartment2'],
            "city" => $_POST['city2'],
            "phone" => $_POST['phone2'],
            "company" => $_POST['company2'],
            "province" => $_POST['state2'],
            "country" => $_POST['country2'],
            "zip" => $_POST['postal2']
        );
        $line_item = array();
        $line_item_name = array();
		$crt_item=json_decode($_POST['cart_item'],true);
		$i=0;
        foreach ($crt_item as $key=>$val) {
            $items = array(
//                "title" => $val['title'],
//                'product_id' => $val['product_id'],
                'variant_id' => $val[$i]['variant_id'],
                'quantity' => $val[$i]['quantity'],
                'price' => $val[$i]['price'] / 100,
                'title' => $val[$i]['title']
            );
            $title = array(
                 'title' => $val[$i]['title']
                );
            $line_item[] = $items;
            $line_item_name[] = $title;
        $i++;}
        //$nonce = Yii::$app->request->get('nonce');
        $cart_token = $_POST['token'];
        $gateway =$_POST['gateway'];
        $name = $_POST["first_name"] . " " . $_POST["last_name"];
 
					 $orderDatanew = array('order' => array(
                    'email' => $_POST['email'],
                    //'send_fulfillment_receipt'=> true,
                    'send_receipt' => true,
                    'line_items' => $line_item,
                    //'customer' =>$customer,
                    'billing_address' => $billing_address,
                    'taxes_included' => false,
                    'shipping_address' => $shipping_address,
                    'financial_status' => "paid",
                    'fulfillment_status' => "unfulfilled",
                    'checkout_token' => $cart_token
                )
            );
            if (!empty($_POST['customer'])) {
                $customer = array(
                    "id" => $_POST['customer'],
                );
                $orderDatanew['order']['customer'] = $customer;
				$customer_id=$_POST['customer'];
            } else {
				$customer_id='';
                $orderDatanew['order']['buyer_accepts_marketing'] = true;
            }
			 if (!empty($_POST['coupon_type'])) {
                    $discount_code = array(
                        "code" => strtoupper($_POST['coupon_name']),
                        "amount" => abs($_POST['coupon_amount_rate']),
                        "type" => $_POST['coupon_type']
                    );
                    $discount_codes[] = $discount_code;
                    $orderDatanew['order']['discount_codes'] = $discount_codes;
                }
                if (!empty($_POST['shipping_rates_amount'])) {
                    $ship = array(
                        'title' => $_POST['shipping_rates_title'],
                        'price' => $_POST['shipping_rates_amount']
                    );
                    $shippinglines[] = $ship;
                    $orderDatanew['order']['shipping_lines'] = $shippinglines;
                }
               
                if ($_POST['tax_price'] != '' && $_POST['tax_name'] != '') {
                    $tax_amt = $_POST['tax_price'];
                     $tax_rate = 0;
                    $tax = array(
                        "title" => $_POST['tax_name'],
                        "price" => $tax_amt,
                        "rate" => $tax_rate,
                    );
                    $taxlines[] = $tax;
                    $orderDatanew['order']['tax_lines'] = $taxlines;
                    $orderDatanew['order']['total_tax'] = $tax_amt;
                }
                if ($currency == 'EUR') {
                    $orderDatanew['order']['taxes_included'] = true;
                }
                $txn = array(
                    "kind" => "sale",
                    "status" => "success",
                    "amount" => $total_price,
                    "gateway" => $gateway,
                );
                $transacrtion[] = $txn;
                $orderDatanew['order']['transactions'] = $transacrtion;
             
                $orderData = $sc->call('POST', "/admin/orders.json", $orderDatanew);		
					if (!empty($orderData['errors'])) {
                    // fwrite($logs, "\n New Order error " . json_encode($orderData));
                    $err_response['status'] = 'fail';
                    $err_response['message'] = 'something went wrong';

                    if (!empty($orderData['errors']['customer'])) {
                        $err_response['message'] = $orderData['errors']['customer'][0];
                    }
                    $response = json_encode($err_response);
                    echo "docheckout(" . $response . ");";
                    exit;
                } 
                $orderid = $orderData['id']; 
                if ($orderData['id']) {
                    $store_id = $Store->id;
                    $payment_mode = "In-Store Cash Payment";
                    $paymenyResponse = "Pending";
                    $order_name = $orderData['name'];
                    $this->actionSavetransactiondetail($store_id, $orderid, $order_name, $paymenyResponse, $payment_mode, $name, $email, $_POST['postal'], $_POST['country'], $gateway, $amount, $currency, $customer_id);

                    $dd = array('status_message' => "payment has been created successfully.");
                    $new_url = str_replace('checkout.shopify.com', $shop, $orderData['order_status_url']);
                    $dd['response'] = $new_url;
                    $dd['order_id'] = $orderid;
                    $response = json_encode($dd);
					
					$model=new MobileMoneyPayments();
					$model->card_number=$_POST['cardNumber'];
					$model->card_expmonth=$_POST['cardExpMonth'];
					$model->card_expyear=$_POST['cardExpYear'];
					$model->grandTotalAmount='90.01';
					$model->currency='USD';
					$model->merchant_code=$referenceCode;
					$model->requestID=$reply->requestID;
					$model->decision=$reply->decision;
					$model->reasonCode=$reply->ccCaptureReply->reasonCode;
					$model->requestToken=$reply->requestToken;
					$model->reconciliationID=$reply->ccCaptureReply->reconciliationID;
					$model->paymentNetworkTransactionID=$reply->ccAuthReply->paymentNetworkTransactionID;
					$model->authorizationCode=$reply->ccAuthReply->authorizationCode;
					$model->cardType=$reply->card->cardType;
					$model->terminalID=$reply->pos->terminalID;
					$model->orderid= $orderid;
					$model->created_at= date('m/d/Y');
					$model->updated_at= date('m/d/Y');
					$model->save(false);
					
					
                   echo "docheckout(" . $response . ");";
                }  
					
					
				}
				
		
	}
}