<?php

namespace app\controllers;

use Yii;

use yii\base\InvalidArgumentException;
use yii\web\BadRequestHttpException;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\filters\AccessControl;
use common\models\LoginForm;
//additional
use app\models\Store;
use app\models\ShopifyClient;
use app\models\Configurations;
use app\models\Orders;
use app\models\CartDetails;
use app\models\Directpay;
//use yii\helpers\Url;
use SquareConnect;
use CybsSoapClient;
use yii\web\Response;
use Dipnot\DirectPayOnline\Config;
use Dipnot\DirectPayOnline\Model\Transaction;
use Dipnot\DirectPayOnline\Model\Service;
use Dipnot\DirectPayOnline\Request\CreateTokenRequest;
use Dipnot\DirectPayOnline\Request\VerifyTokenRequest;
/**
 * Site controller
 */
class DirectpayController extends Controller {
    public function beforeAction($action) {
        $this->enableCsrfValidation = false;
        return parent::beforeAction($action);
    }
	public function actionPayment_form($data) {
		$refrence_code = time().rand();
		$Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();		
		$model = new Orders();
		$model->store_id = $Store->id;
		$model->data = $data;
		$model->reference_no = $refrence_code;
		$model->save(false);
		
		$detail = json_decode($data);
		$items = $detail->cart_item->items;
		$billing = $detail->billing_address;
		$amount = $detail->total_price;
		$currency = $detail->currency;
		
		$config = new Config();  
		$config->setCompanyToken("84CD6A7D-DA70-4B46-A34F-2D02F3F18298");  
		//$config->setTestMode(false);
		
		$transaction = new Transaction($amount, $currency);
		$transaction->setRedirectURL("https://checkout.zmart.online/web/index.php/directpay/response");
		$transaction->setBackURL("https://zmart.online/a/checkout");
		$transaction->setCompanyRef($refrence_code);
		$transaction->setCustomerEmail($detail->email);
		$transaction->setCustomerFirstName($billing->first_name);
		$transaction->setCustomerLastName($billing->last_name);
		$transaction->setCustomerAddress($billing->address);
		$transaction->setCustomerCity($billing->city);
		$transaction->setCustomerCountry($billing->country);
		$transaction->setCustomerZip($billing->postal);
		$transaction->setCustomerPhone($billing->phone);
		$transaction->setDefaultPaymentCountry('Zambia');
		//$transaction->setBlockPayment('PP');
		
		$serviceId = substr($items[0]->variant_id, 0, 4);
		$serviceTitle = preg_replace('/&/', 'and', $items[0]->title);
		$service = new Service($serviceTitle, 38715, date('Y/m/d H:i'));

		$createTokenRequest = new CreateTokenRequest($config);  
		$createTokenRequest->setTransaction($transaction);  
		$createTokenRequest->addService($service);
		$createToken = $createTokenRequest->execute();  
		if(isset($createToken["TransToken"])){
			$paymentUrl = $createTokenRequest->getPaymentUrl($createToken["TransToken"]); 
			return $this->redirect('https://secure.3gdirectpay.com/pay.asp?ID='.$createToken["TransToken"].'');
		}else{
			echo "<pre>";
			print_r($createToken);
			die;
		}
	}
	public function actionResponse() {
		$Store = Store::find()->where(['name' => 'z-mart-zambia.myshopify.com'])->one();
		$shopify_api_version = Yii::$app->params['SHOPIFY_API_VERSION'];
		$token = $Store->token;
		$shop = $Store->name;
		$sc = new ShopifyClient($shop, $token, Yii::$app->params['APP_KEY'], Yii::$app->params['SECRET_KEY']);
		$orderexist = Orders::find()->where(['reference_no' => $_REQUEST['CompanyRef']])->one();
		$detail = json_decode($orderexist->data);
		if($_REQUEST['CCDapproval'] !='' && $_REQUEST['TransID'] != ''){
			$email = $detail->email;
			$cart_item = $detail->cart_item;
			$currency = $detail->currency;
			$accepts_marketing = $detail->accept_marketing;
			$shipping_amount = 0;
			$shipping_title = '';
			$shipping_rates = $detail->shipping_rates;
			if (isset($shipping_rates)) {
				$shipping_title = $shipping_rates->title;
				$shipping_amount = $shipping_rates->amount;
			}
			$total_price = (float) $detail->total_price;
			$amount = $total_price * 100;
			$billing = $detail->billing_address;
			$location1 = $detail->location;
			$location_address='';
			if(!empty($location1->name)){
				$location_address = $location1->name;
			}
			$billing_address = array(
				"first_name" => $billing->first_name,
				"last_name" => $billing->last_name,
				"address1" => $billing->address,
				"address2" => $billing->apartment,
				"city" => $billing->city,
				"phone" => $billing->phone,
				"company" => $billing->company,
				"province" => $billing->state,
				"country" => $billing->country,
				"zip" => $billing->postal
			);
			$shipping = $detail->shipping_address;
			$shipping_address = array(
				"first_name" => $shipping->first_name,
				"last_name" => $shipping->last_name,
				"address1" => $shipping->address,
				"address2" => $shipping->apartment,
				"city" => $shipping->city,
				"phone" => $shipping->phone,
				"company" => $shipping->company,
				"province" => $shipping->state,
				"country" => $shipping->country,
				"zip" => $shipping->postal
			);
			$line_item = array();
			$line_item_name = array();
			foreach ($cart_item->items as $key => $val) {
				$items = array(
					'variant_id' => $val->variant_id,
					'quantity' => $val->quantity,
					'price' => $val->price / 100,
					'title' => $val->title,
					
				);
				$title = array(
					 'title' => $val->title
					);
				$line_item[] = $items;
				$line_item_name[] = $title;
			}
			$cart_token = $detail->token;
			$gateway =  $detail->gateway;
			$name = $billing->first_name . " " . $billing->last_name;
			$payment_status = "";
			$customer_id = "";
			$paymentDate = date("Y-m-d H:i:s");
			$orderDatanew = array('order' => array(
					'email' => $email,
				    'send_receipt' => true,
					'line_items' => $line_item,
					'billing_address' => $billing_address,
				    'taxes_included' => false,
					'shipping_address' => $shipping_address,
					'financial_status' => "paid",
					'fulfillment_status' => "unfulfilled",
					'checkout_token' => $cart_token,
					'gateway'=> 'Direct Pay Online',
				)
			);
			if ($detail->customer != '') {
				$customer = array(
					"id" => $detail->customer,
				);
				$orderDatanew['order']['customer'] = $customer;
				$orderDatanew['order']['customer']['accepts_marketing'] = $accepts_marketing;
			}
			$orderDatanew['order']['buyer_accepts_marketing'] = $accepts_marketing;
			$coupon = $detail->coupon_detail;
			if ($coupon->coupon_type != '') {
			  $discount_code = array(
				    "code" => strtoupper($coupon->coupon_name),
					"amount" => abs($coupon->coupon_amount_rate),
					"type" => $coupon->coupon_type
				);
			   $discount_codes[] = $discount_code;
			   $orderDatanew['order']['discount_codes'] = $discount_codes;
			}
			if(!empty($location1)){
				$ship = array(
					'title' => 'pickup ('.$location1->name.')',
					'price' => $shipping_rates->amount,
					'code'=>'pickup ('.$location1->name.')',
				);
				$shippinglines[] = $ship;
				$orderDatanew['order']['shipping_lines'] = $shippinglines;
			}
			else if ($shipping_rates->amount != '') {
				$ship = array(
					'title' => $shipping_rates->title,
					'price' => $shipping_rates->amount
				);
				$shippinglines[] = $ship;
				$orderDatanew['order']['shipping_lines'] = $shippinglines;
		    }
			$tax = $detail->tax_detail;
			if ($tax->tax_price != '' && $tax->tax_name!= '') {
			    $tax_amt = $tax->tax_price;
				 $tax_rate = 0;
				$tax = array(
					"title" => $tax->tax_name,
				   "price" => $tax_amt,
					"rate" => $tax_rate,
				); 
				$taxlines[] = $tax;
				$orderDatanew['order']['tax_lines'] = $taxlines;
				$orderDatanew['order']['total_tax'] = $tax_amt;
			}
			if ($currency == 'EUR') {
				$orderDatanew['order']['taxes_included'] = true;
			}
					  
			$txn = array(
				"kind" => "sale",
				"status" => "success",
				"amount" => $detail->total_price,
				"gateway" => "Direct Pay Online"
			);
            $transacrtion[] = $txn;
            $orderDatanew['order']['transactions'] = $transacrtion;
			$orderData = $sc->call('POST', "/admin/api/$shopify_api_version/orders.json", $orderDatanew);
			if($orderData){
				$sc->call('POST', "/cart/clear.js");
				if($billing->postal){
					$postal=$billing->postal;
				}else{
					$postal=$shipping->postal;
				}
				if($billing->country){
					$country=$billing->country;
				}else{
					$country=$shipping->country;
				}
				$orderexist->store_id = $Store->id;
				$orderexist->order_id = $orderData['id'];
				$orderexist->order_name = $orderData['order_number'];
				$orderexist->customer_name = $orderData['customer']['first_name'];
				$orderexist->email = $detail->email;
				$orderexist->pin = $billing->postal;
				$orderexist->country = $country;
				$orderexist->status = 'paid';
				$orderexist->amount = $detail->total_price;
				$orderexist->currency = $detail->currency;
				$orderexist->payment_mode = 'Direct Pay Online';
				$orderexist->reference_no = $_REQUEST['CompanyRef'];
				$orderexist->order_status_url = $orderData['order_status_url'];
				$orderexist->total_price_usd = $orderData['total_price_usd'];
				$orderexist->save(false);
				
				$config = new Config();  
				$config->setCompanyToken("84CD6A7D-DA70-4B46-A34F-2D02F3F18298");  
				
				$verifyTokenRequest = new VerifyTokenRequest($config);
				$verifyTokenRequest->setTransactionToken($_GET["TransactionToken"]);
				$verifyToken = $verifyTokenRequest->execute();
				
				$payment = new Directpay();
				$payment->store_id = $Store->id;
				$payment->order_id = $orderData['id'];
				$payment->reference_no = $_REQUEST['CompanyRef'];
				$payment->TransID = $_REQUEST['TransID'];
				$payment->TransactionApproval = $verifyToken['TransactionApproval'];
				$payment->CustomerCreditType = $verifyToken['CustomerCreditType'];
				$payment->CustomerCredit = $verifyToken['CustomerCredit'];
				$payment->MobilePaymentRequest = $verifyToken['MobilePaymentRequest'];
				$payment->TransactionFinalCurrency = $verifyToken['TransactionFinalCurrency'];
				$payment->TransactionFinalAmount = $verifyToken['TransactionFinalAmount'];
				$payment->TransactionToken = $_REQUEST['TransactionToken'];
				$payment->save(false);
			}
			$orderid = $orderexist->order_id;
			$url = $orderexist->order_status_url;
			return $this->redirect($url);
		}
	}
}