<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "mobile_money_payments".
 *
 * @property int $id
 * @property string|null $card_number
 * @property int|null $card_expmonth
 * @property int|null $card_expyear
 * @property string|null $grandTotalAmount
 * @property string|null $currency
 * @property string|null $merchant_code
 * @property string|null $requestID
 * @property string|null $decision
 * @property int|null $reasonCode
 * @property string|null $requestToken
 * @property string|null $reconciliationID
 * @property string|null $paymentNetworkTransactionID
 * @property string|null $authorizationCode
 * @property int|null $cardType
 * @property string|null $terminalID
 * @property string|null $created_at
 * @property string|null $udpated_at
 */
class MobileMoneyPayments extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'mobile_money_payments';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['card_expmonth', 'card_expyear', 'reasonCode', 'cardType'], 'integer'],
            [['requestToken'], 'string'],
            [['card_number', 'merchant_code', 'requestID', 'decision', 'reconciliationID', 'paymentNetworkTransactionID', 'authorizationCode', 'terminalID', 'created_at', 'udpated_at'], 'string', 'max' => 255],
            [['grandTotalAmount', 'currency'], 'string', 'max' => 20],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'card_number' => 'Card Number',
            'card_expmonth' => 'Card Expmonth',
            'card_expyear' => 'Card Expyear',
            'grandTotalAmount' => 'Grand Total Amount',
            'currency' => 'Currency',
            'merchant_code' => 'Merchant Code',
            'requestID' => 'Request ID',
            'decision' => 'Decision',
            'reasonCode' => 'Reason Code',
            'requestToken' => 'Request Token',
            'reconciliationID' => 'Reconciliation ID',
            'paymentNetworkTransactionID' => 'Payment Network Transaction ID',
            'authorizationCode' => 'Authorization Code',
            'cardType' => 'Card Type',
            'terminalID' => 'Terminal ID',
            'created_at' => 'Created At',
            'udpated_at' => 'Udpated At',
        ];
    }
}
