<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "orders".
 *
 * @property int $id
 * @property int $store_id
 * @property string $order_id
 * @property string $order_name
 * @property string $customer_name
 * @property string $email
 * @property string $pin
 * @property string $country
 * @property string $status
 * @property string $sequare_payment_id
 * @property int $amount
 * @property string $currency
 * @property string $card_status
 * @property string $card_brand
 * @property int $last_4
 * @property string $expiry
 * @property string $location_id
 * @property string $square_order_id
 * @property string $payment_mode
 * @property string $created_at
 * @property string $updated_at
 */
class Orders extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'orders';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['store_id', 'sequare_payment_id', 'amount', 'currency', 'card_status', 'card_brand', 'last_4', 'expiry', 'location_id', 'square_order_id', 'payment_mode'], 'required'],
            [['store_id', 'amount', 'last_4'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['order_id', 'order_name', 'customer_name', 'email', 'pin', 'country', 'status', 'sequare_payment_id', 'square_customer_id'], 'string', 'max' => 255],
            [['currency'], 'string', 'max' => 5],
            [['card_status', 'card_brand', 'location_id', 'square_order_id', 'payment_mode'], 'string', 'max' => 128],
            [['expiry'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'store_id' => 'Store ID',
            'order_id' => 'Order ID',
            'order_name' => 'Order Name',
            'customer_name' => 'Customer Name',
            'email' => 'Email',
            'pin' => 'Pin',
            'country' => 'Country',
            'status' => 'Status',
            'sequare_payment_id' => 'Sequare Payment ID',
            'amount' => 'Amount',
            'currency' => 'Currency',
            'card_status' => 'Card Status',
            'card_brand' => 'Card Brand',
            'last_4' => 'Last 4',
            'expiry' => 'Expiry',
            'location_id' => 'Location ID',
            'square_order_id' => 'Square Order ID',
            'square_customer_id' => 'Square Customer ID',
            'payment_mode' => 'Payment Mode',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
