<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Orders;

/**
 * OrdersSearch represents the model behind the search form of `app\models\Orders`.
 */
class OrdersSearch extends Orders
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'store_id', 'amount', 'last_4'], 'integer'],
            [['order_id', 'order_name', 'customer_name', 'email', 'pin', 'country', 'status', 'sequare_payment_id', 'currency', 'card_status', 'card_brand', 'expiry', 'location_id', 'square_order_id', 'square_customer_id', 'payment_mode', 'created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Orders::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'store_id' => $this->store_id,
            'amount' => $this->amount,
            'last_4' => $this->last_4,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'order_id', $this->order_id])
            ->andFilterWhere(['like', 'order_name', $this->order_name])
            ->andFilterWhere(['like', 'customer_name', $this->customer_name])
            ->andFilterWhere(['like', 'email', $this->email])
            ->andFilterWhere(['like', 'pin', $this->pin])
            ->andFilterWhere(['like', 'country', $this->country])
            ->andFilterWhere(['like', 'status', $this->status])
            ->andFilterWhere(['like', 'sequare_payment_id', $this->sequare_payment_id])
            ->andFilterWhere(['like', 'currency', $this->currency])
            ->andFilterWhere(['like', 'card_status', $this->card_status])
            ->andFilterWhere(['like', 'card_brand', $this->card_brand])
            ->andFilterWhere(['like', 'expiry', $this->expiry])
            ->andFilterWhere(['like', 'location_id', $this->location_id])
            ->andFilterWhere(['like', 'square_order_id', $this->square_order_id])
            ->andFilterWhere(['like', 'square_customer_id', $this->square_customer_id])
            ->andFilterWhere(['like', 'payment_mode', $this->payment_mode]);

        return $dataProvider;
    }
}
