<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "refunds".
 *
 * @property int $id
 * @property int $store_id
 * @property string $order_id
 * @property string $refund_id
 * @property string $refund_status
 * @property string $transaction_id
 * @property string $square_refund_id
 * @property string $status
 * @property string $amount
 * @property string $reason
 * @property string $currency
 * @property string $created_at
 * @property string $updated_at
 */
class Refunds extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'refunds';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['store_id', 'status', 'amount', 'reason'], 'required'],
            [['store_id'], 'integer'],
            [['reason'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
            [['order_id', 'refund_id', 'refund_status', 'transaction_id', 'square_refund_id', 'status', 'amount'], 'string', 'max' => 255],
            [['currency'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'store_id' => 'Store ID',
            'order_id' => 'Order ID',
            'refund_id' => 'Refund ID',
            'refund_status' => 'Refund Status',
            'transaction_id' => 'Transaction ID',
            'square_refund_id' => 'Square Refund ID',
            'status' => 'Status',
            'amount' => 'Amount',
            'reason' => 'Reason',
            'currency' => 'Currency',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
