<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ConfigurationsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Configurations';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="container configurations-index">
    <div class="card">
        <div class="card-header">
            <h5 class="card-title">Square Payment Settings</h5>
            <p class="card-subtitle mb-2 text-muted">Your integration keys are necessary to integrate to Square Payments API. They should be protected the same way you protect your passwords.</p>
        </div>
        <div class="card-body">
            <?php $form = ActiveForm::begin(['id' => 'square-config-form', 'method' => 'POST', 'action' => 'set-config']); ?>
                <div class="seo-setting col-md-8">             
                    <div class="row">
                        <div class="col-lg-12 mt-3 mb-3">
                            <h5>Production Integration keys</h5>
                        </div> 
                    </div>
                    <div class="row mb-2">
                        <h6 class="col-md-4 col-sm-12 col-sx-12">Enable Production Account</h6> 
                        <span class="col-md-8 col-sm-12 col-sx-12">
                            <input id="enable_square" type="checkbox" name="enable_square" value="<?php if (isset($config['enable_square'])) echo $config['enable_square']; else echo "0"; ?>" onclick="myFunction()" >
                        </span>
                    </div>
                    <div class="form-group row">
                        <label for="applicationId" class="col-sm-4 col-form-label">Application Id</label>
                        <div class="col-sm-6">
                          <input id="live_application_id" class="form-control" name="live_application_id" type="text" value="<?php echo $config['live_application_id']; ?>">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="applicationId" class="col-sm-4 col-form-label">Access Token</label>
                        <div class="col-sm-6">
                          <input id="live_access_token" class="form-control" name="live_access_token" type="text" value="<?php echo $config['live_access_token']; ?>">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="applicationId" class="col-sm-4 col-form-label">Location Id</label>
                        <div class="col-sm-6">
                          <input id="live_location_id" class="form-control" name="live_location_id" type="text" value="<?php echo $config['live_location_id']; ?>">
                        </div>
                    </div>
                </div>
                <hr class="mt-5 mb-5"/>
                <div class="seo-setting col-md-8">   
                    <div class="row">
                        <div class="col-lg-12 mb-3">
                            <h5>Sandbox Integration keys</h5>
                        </div> 
                    </div>
                    <div class="row mb-2">
                        <h6 class="col-lg-4 col-md-6 col-sm-12 col-sx-12">Enable Sandbox Account</h6> 
                        <span class="col-lg-8 col-md-6 col-sm-12 col-sx-12">
                            <input type="checkbox" id="sandbox" name="sandbox" value="1" <?php if ($config['sandbox'] == 1) echo "checked"; ?>>
                        </span>
                    </div>
                    <div class="form-group row">
                        <label for="applicationId" class="col-sm-4 col-form-label">Application Id</label>
                        <div class="col-sm-6">
                          <input id="sandbox_application_id" class="form-control" name="sandbox_application_id" type="text" value="<?php echo $config['sandbox_application_id']; ?>">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="accessToken" class="col-sm-4 col-form-label">Access Token</label>
                        <div class="col-sm-6">
                          <input class="form-control" id="sandbox_access_token" name="sandbox_access_token" type="text" value="<?php echo $config['sandbox_access_token']; ?>">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="sandbox_application_id" class="col-sm-4 col-form-label">Location Id</label>
                        <div class="col-sm-6">
                          <input id="sandbox_location_id" class="form-control" name="sandbox_location_id" type="text" value="<?php echo $config['sandbox_location_id']; ?>">
                        </div>
                    </div>
                    <div class="row">
                        <span class="col-lg-10 col-md-10 col-sm-12 col-sx-12 text-right mt-3 mb-3"> 
                            <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'id' => 'square_save']) ?>
                        </span>
                    </div>
                    <input type="hidden" name="shop" value="<?=  $config['shop']; ?>">
                </div>
            <?php ActiveForm::end(); ?>	
        </div>
    </div>
</div>