<?php

use yii\helpers\Html;
use yii\bootstrap\ActiveForm;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ConfigurationsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Configurations';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="container configurations-index">
    <div class="card">
        <div class="card-header">
            <h5 class="card-title">Stripe Payment Settings</h5>
            <p class="card-subtitle mb-2 text-muted">Your integration keys are necessary to integrate to Stripe Payments API. They should be protected the same way you protect your passwords.</p>
        </div>
        <div class="card-body">
            <?php $form = ActiveForm::begin(['id' => 'square-config-form', 'method' => 'POST', 'action' => 'set-config']); ?>
            <div class="seo-setting col-md-8">             
                <div class="row">
                    <div class="col-lg-12 mt-3 mb-3">
                        <h5>Production Integration keys</h5>
                    </div> 
                </div>
                <div class="row mb-2">
                    <h6 class="col-md-4 col-sm-12 col-sx-12">Enable Production Account</h6> 
                    <span class="col-md-8 col-sm-12 col-sx-12">
                        <input id="enable_square" type="checkbox" name="enable_square" value="<?= isset($config['enable_square']) && $config['enable_square'] == 1 ? $config['enable_square'] : 0; ?>" onclick="myFunction()" 
                               <?= isset($config['enable_square']) && $config['enable_square'] == 1 ? 'checked' : ''; ?> >
                    </span>
                </div>
                <div class="form-group row">
                    <label for="applicationId" class="col-sm-4 col-form-label">Application Id</label>
                    <div class="col-sm-6">
                        <input id="live_application_id" class="form-control" name="live_application_id" type="text" value="<?php echo $config['live_application_id']; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="applicationId" class="col-sm-4 col-form-label">Access Token</label>
                    <div class="col-sm-6">
                        <input id="live_access_token" class="form-control" name="live_access_token" type="text" value="<?php echo $config['live_access_token']; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="applicationId" class="col-sm-4 col-form-label">Location Id</label>
                    <div class="col-sm-6">
                        <input id="live_location_id" class="form-control" name="live_location_id" type="text" value="<?php echo $config['live_location_id']; ?>">
                    </div>
                </div>
            </div>
            <hr class="mt-5 mb-5"/>
            <div class="seo-setting col-md-8">   
                <div class="row">
                    <div class="col-lg-12 mb-3">
                        <h5>Sandbox Integration keys</h5>
                    </div> 
                </div>
                <div class="row mb-2">
                    <h6 class="col-lg-4 col-md-6 col-sm-12 col-sx-12">Enable Sandbox Account</h6> 
                    <span class="col-lg-8 col-md-6 col-sm-12 col-sx-12">
                        <input type="checkbox" id="sandbox" name="sandbox" value="<?= isset($config['enable_square']) && $config['enable_square'] == 1 ? $config['enable_square'] : 0; ?>" <?= $config['sandbox'] == 1 ? "checked" : ''; ?> onclick="myFunction()">
                    </span>
                </div>
                <div class="form-group row">
                    <label for="applicationId" class="col-sm-4 col-form-label">Application Id</label>
                    <div class="col-sm-6">
                        <input id="sandbox_application_id" class="form-control" name="sandbox_application_id" type="text" value="<?php echo $config['sandbox_application_id']; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="accessToken" class="col-sm-4 col-form-label">Access Token</label>
                    <div class="col-sm-6">
                        <input class="form-control" id="sandbox_access_token" name="sandbox_access_token" type="text" value="<?php echo $config['sandbox_access_token']; ?>">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="sandbox_application_id" class="col-sm-4 col-form-label">Location Id</label>
                    <div class="col-sm-6">
                        <input id="sandbox_location_id" class="form-control" name="sandbox_location_id" type="text" value="<?php echo $config['sandbox_location_id']; ?>">
                    </div>
                </div>
                <div class="row">
                    <span class="col-lg-10 col-md-10 col-sm-12 col-sx-12 text-right mt-3 mb-3"> 
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'id' => 'square_save']) ?>
                    </span>
                </div>
                <input type="hidden" name="shop" value="<?= $config['shop']; ?>">
            </div>
            <?php ActiveForm::end(); ?>	
        </div>
    </div>
</div>
<script>
    // Checkbox to enable disable square payment

function myFunction() {
    var checkBox = document.getElementById("enable_square");
    var checkBox_sandbox = document.getElementById("sandbox");
    if (checkBox.checked == true) {
        document.getElementById("enable_square").value = '1';
    } else {
        document.getElementById("enable_square").value = '0';
    }

    if (checkBox_sandbox.checked == true) {
        document.getElementById("sandbox").value = '1';
    } else {
        document.getElementById("sandbox").value = '0';
    }

}

    if ((jQuery('#enable_square').val() == '0') || (jQuery('#enable_square').val() == '') || (typeof jQuery('#enable_square').val() == 'undefined')) {

        $("#enable_square").removeAttr("checked");

    } else if ((jQuery('#enable_square').val() == '1')) {

        $("#enable_square").attr("checked", "checked");

    }


    jQuery(document).ready(function ($) {

        $("#square_save").on('click', function (event) {

            event.preventDefault();

            if ($('#enable_square').is(':checked') && $('#sandbox').is(':checked') && (isblankSquare_live() || isblankSquare_test())) {

                alert("Fill all fields in Production & Sandbox section of Square Payment Settings.");

            } else if (!$('#enable_square').is(':checked') && $('#sandbox').is(':checked') && (isblankSquare_test())) {

                alert("Enter all fields in Sandbox section of Square Payment Settings.");

            } else if ($('#enable_square').is(':checked') && !$('#sandbox').is(':checked') && (isblankSquare_live())) {

                alert("Enter all fields in Production section of Square Payment Settings.");

            } else if (!$('#enable_square').is(':checked') && !$('#sandbox').is(':checked')) {

                $("#square-config-form").submit();

            } else {

                $("#square-config-form").submit();

            }

        });

    })



    function isblankSquare_test() {

        if ((jQuery('#sandbox_application_id').val() == '') || (jQuery('#sandbox_access_token').val() == '') || (jQuery('#sandbox_location_id').val() == '')) {

            return true;

        } else {

            return false;

        }

    }

    function isblankSquare_live() {

        if ((jQuery('#live_application_id').val() == '') || (jQuery('#live_access_token').val() == '') || (jQuery('#live_location_id').val() == '')) {

            return true;

        } else {

            return false;

        }

    }
</script>